/**
A Demo showing how to generate land from nothing. By Chibi-Gohan0
**/
world
	mob=/mob/Player
	turf=/turf/Water
	view="50x50"
turf
	icon = 'icons.dmi'
	Grass
		icon_state = "grass"
	Water
		icon_state = "water"
		density = 1
obj
	seed
		icon = 'icons.dmi'
		var/list/Spots = list()
mob/Player
	icon = 'icons.dmi'
	icon_state = "Player"
	verb/MyGenerator()
		set background = 1
		for(var/turf/T in world) //Loop through all turfs in the world.
			if(prob(10)) //10% Chance of creating a seed on that turf.
				new/obj/seed(T)
		for(var/obj/seed/seed1 in world)
			for(var/obj/seed/seed2 in world)
				if(seed1 != seed2)
					seed1.Spots += get_dist(seed2,seed1) //Add the distance from seed1 to seed2 to their own list.
		world<<"Initializing Land Creation."
		for(var/obj/seed/S in world)
			for(var/obj/seed/D in world)
				if(get_dist(S,D) == max(S.Spots)||get_dist(S,D) == min(D.Spots)) //If the distance from seed S to seed D equals the higest item is S's list
																				 //Or if the distance equals the lowest number in D's list
					for(var/turf/T in view(1,S))
						if(get_dist(S,D) == get_dist(T,D)) //If the distances equal eachother.
							new/turf/Grass(T)//Create a Grass turf.
		world<<"Initializing Land Ajustments."
		for(var/turf/Water/W in world)
			var/A=0
			var/B=0
			//Fixing Choppy look.
			for(var/turf/Grass/G in oview(1,W))
				if(locate(G.x,G.y,G.z)==locate(W.x-1,W.y,W.z)||locate(G.x,G.y,G.z)==locate(W.x+1,W.y,W.z))
					A++
				if(locate(G.x,G.y,G.z)==locate(W.x,W.y+1,W.z)||locate(G.x,G.y,G.z)==locate(W.x,W.y-1,W.z))
					B++
			if(A == 2)
				new/turf/Grass(W)
			if(B == 2)
				new/turf/Grass(W)
		world<<"Initializing Land Trimming."
		for(var/turf/Grass/G in world)
			for(var/turf/Water/W in view(1,G))
				W.overlays += image('icons.dmi',icon_state="[get_dir(G,W)]") //Adds border to grass.
		world<<"Map Creation Complete"
	verb/DelSeed()
		for(var/obj/seed in world)
			del(seed)
	New()
		..()
		loc=locate(1,1,1)